var xmpp = require('node-xmpp');

module.exports = new SimpleXMPP();

function SimpleXMPP() {
    
    var conn;

    var chatCallback;
    var errorCallback;
    var onlineCallback;

    this.onChat = function(callback) {
        chatCallback = callback;
    };

    this.onError = function(callback) {
        errorCallback = callback;
    };

    this.onOnline = function(callback) {
        onlineCallback = callback;
    };

    this.send = function(to, message) {
        
        if(conn) {
            conn.send(new xmpp.Element('message',
            { 
                to: to, // to
                type: 'chat'}).
                c('body').
                t(message));
        } else {
            console.log('not connected yet!');
        }
    };

    this.connect = function(params) {

        conn = new xmpp.Client(params);

        conn.on('online', function(){
            conn.send(new xmpp.Element('presence'));
            if(onlineCallback) {
                onlineCallback();
            }
        });

        conn.on('stanza', function(stanza) {
            if (stanza.is('message') && stanza.attrs.type !== 'error') {

                var chat = stanza.children[0];
                if(chat.name == 'body') {
                    var message = stanza.children[0].children[0];
                    var from = stanza.attrs.from;
                    if(chatCallback) {
                        chatCallback(from, message);
                    }   
                }
            }
        });

        conn.on('error', function(err) {
            if(errorCallback) {
                errorCallback(err);
            }
        });

    };


    
}


